using System;
using ThinkGeo.MapSuite.Core;
using System.Drawing;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Web.UI;

namespace CSSamples.Samples
{
    public partial class DisplayASimpleMap : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#B3C6D4"));
                Map1.CurrentExtent = new RectangleShape(-140, 60, 140, -60);
                Map1.MapUnit = GeographyUnit.DecimalDegree;

                ShapeFileFeatureLayer worldLayer = new ShapeFileFeatureLayer(MapPath("~/SampleData/world/cntry02.shp"));
                worldLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.FromArgb(255, 243, 239, 228), GeoColor.FromArgb(255, 218, 193, 163), 1);
                worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

                Map1.StaticOverlay.Layers.Add(worldLayer);

                // The following two lines of code enable the client and server caching.
                // If you enable these features it will greatly increase the scalability of your
                // mapping application however there some side effects that may be counter intuitive.
                // Please read the white paper on web caching or the documentation regarding these methods.

                //Map1.StaticOverlay.ClientCache.CacheId = "WorldOverlay";
                //Map1.StaticOverlay.ServerCache.CacheDirectory = MapPath("~/ImageCache/" + Request.Path);

                TreeNode node1 = new TreeNode("Tree Node1");
                TreeNode node2 = new TreeNode("Tree Node2");

                TreeView1.Nodes.Add(node1);
                TreeView1.Nodes.Add(node2);

                AddHtmlAnchors();
            }
        }

        private void AddHtmlAnchors()
        {
            Panel1.Controls.Add(GetHtmlAnchor("Label in a Panel1"));
            Panel1.Controls.Add(new LiteralControl("<br/>"));
            Panel1.Controls.Add(GetHtmlAnchor("Label in a Panel2"));
        }

        private HtmlAnchor GetHtmlAnchor(string text)
        {
            HtmlAnchor anchor = new HtmlAnchor();
            anchor.InnerText = text;
            anchor.HRef = "#";
            anchor.Attributes.Add("onmouseover", "alert('over');");
            return anchor;
        }

        protected void TreeNodeChanged(object sender, EventArgs e)
        {
            AddHtmlAnchors();
        }

        protected void Button1_Click(object sender, EventArgs e)
        {
            AddHtmlAnchors();
        }
    }
}
